//ImageReader implementation file

//#define FREEIMAGE_LIB

#include "ImageReader.h"
#include "FreeImage.h"
#include <stdio.h>


ImageReader::ImageReader() {
	//NOTHING
}

Image* ImageReader::readImage(char *filename) {
	FIBITMAP *map_image;
	int width, height;
	RGBQUAD pcolor;
	

	//Initialise the FreeImage library
	FreeImage_Initialise();
	FREE_IMAGE_FORMAT fif = FreeImage_GetFIFFromFilename(filename);
	if(fif != FIF_UNKNOWN) {
		map_image = FreeImage_Load(fif, filename);
	} else {
		printf("IMAGE_READER ERROR: Image format unknown\n");
		return NULL;
	}

	//Get image dimensions
	width = FreeImage_GetWidth(map_image);
	height = FreeImage_GetHeight(map_image);

	Image *image = new Image(width, height);

	for(int i = 0; i<height; i++) {
		for(int j = 0; j<width; j++) {
			if(!FreeImage_GetPixelColor(map_image, j, i, &pcolor)) {
				printf("IMAGE_READER ERROR: reading color of pixel (%d,%d)\n",j,i);
				pcolor.rgbRed = 0; pcolor.rgbGreen = 0; pcolor.rgbBlue = 0;
			}

			image->setPixel(j, i, pcolor.rgbRed, pcolor.rgbGreen, pcolor.rgbBlue);
		}
	}

	FreeImage_DeInitialise();

	return image;
}