#include "WindChanger.h"
#include <qmessagebox.h>

WindChanger::WindChanger(QWidget *parent)
	: QWidget(parent)
{
	m_layout = new QGridLayout(this);
	/*m_layout->setColumnStretch(0,1);
	m_layout->setColumnStretch(1,0);
	m_layout->setColumnStretch(2,1);
	m_layout->setHorizontalSpacing(1);
	*/
	//m_layout->setContentsMargins(1,1,1,1);

	m_buttonN = new MyQPushButton(this);
	m_buttonN->setIcon(QIcon("Images/NButton_nb.png"));
	connect(m_buttonN, SIGNAL(clicked()), this, SLOT(buttonNClicked()));

	m_buttonNE = new MyQPushButton(this);
	m_buttonNE->setIcon(QIcon("Images/NEButton_nb.png"));
	connect(m_buttonNE, SIGNAL(clicked()), this, SLOT(buttonNEClicked()));

	m_buttonE = new MyQPushButton(this);
	m_buttonE->setIcon(QIcon("Images/EButton_nb.png"));
	connect(m_buttonE, SIGNAL(clicked()), this, SLOT(buttonEClicked()));

	m_buttonSE = new MyQPushButton(this);
	m_buttonSE->setIcon(QIcon("Images/SEButton_nb.png"));
	connect(m_buttonSE, SIGNAL(clicked()), this, SLOT(buttonSEClicked()));
	
	m_buttonS = new MyQPushButton(this);
	m_buttonS->setIcon(QIcon("Images/SButton_nb.png"));
	connect(m_buttonS, SIGNAL(clicked()), this, SLOT(buttonSClicked()));

	m_buttonSW = new MyQPushButton(this);
	m_buttonSW->setIcon(QIcon("Images/SWButton_nb.png"));
	connect(m_buttonSW, SIGNAL(clicked()), this, SLOT(buttonSWClicked()));

	m_buttonW = new MyQPushButton(this);
	m_buttonW->setIcon(QIcon("Images/WButton_nb.png"));
	connect(m_buttonW, SIGNAL(clicked()), this, SLOT(buttonWClicked()));

	m_buttonNW = new MyQPushButton(this);
	m_buttonNW->setIcon(QIcon("Images/NWButton_nb.png"));
	connect(m_buttonNW, SIGNAL(clicked()), this, SLOT(buttonNWClicked()));

	m_image = new QLabel();
	m_image->setBackgroundRole(QPalette::Dark);
	m_image->setScaledContents(true);
	QPixmap pix("Images/Compass2_nb.png");
	m_image->setPixmap(pix);

	m_layout->addWidget(m_buttonNW, 0, 0, Qt::AlignRight);
	m_layout->addWidget(m_buttonN, 0, 1, Qt::AlignHCenter);
	m_layout->addWidget(m_buttonNE, 0, 2, Qt::AlignLeft);
	m_layout->addWidget(m_buttonW, 1, 0, Qt::AlignHCenter);
	m_layout->addWidget(m_image, 1, 1, Qt::AlignHCenter);
	m_layout->addWidget(m_buttonE, 1, 2, Qt::AlignHCenter);
	m_layout->addWidget(m_buttonSW, 2, 0, Qt::AlignRight);
	m_layout->addWidget(m_buttonS, 2, 1, Qt::AlignHCenter);
	m_layout->addWidget(m_buttonSE, 2, 2, Qt::AlignLeft);
}

WindChanger::~WindChanger()
{
}

void WindChanger::setWindDirection(QString dir)
{
	if(dir == QString("N")) {
		m_compassPath = new QString("Images/CompassN_nb.png");
	} else if(dir == QString("NE")) {
		m_compassPath = new QString("Images/CompassNE_nb.png");
	} else if(dir == QString("E")) {
		m_compassPath = new QString("Images/CompassE_nb.png");
	} else if(dir == QString("SE")) {
		m_compassPath = new QString("Images/CompassSE_nb.png");
	} else if(dir == QString("S")) {
		m_compassPath = new QString("Images/CompassS_nb.png");
	} else if(dir == QString("SW")) {
		m_compassPath = new QString("Images/CompassSW_nb.png");
	} else if(dir == QString("W")) {
		m_compassPath = new QString("Images/CompassW_nb.png");
	} else if(dir == QString("NW")) {
		m_compassPath = new QString("Images/CompassNW_nb.png");
	} else {
		QMessageBox::information(this, tr("Error"), "Bad wind direction");
	}

	QPixmap pix(*m_compassPath);
	m_image->setPixmap(pix);
}

QString* WindChanger::getWind()
{
	return m_wind;
}

void WindChanger::buttonNClicked()
{
	//QMessageBox::information(this, tr("Console"), "Set wind N");
	m_wind = new QString("N");
	setWindDirection(*m_wind);
	/*m_compassPath = new QString("Images/CompassN_nb.png");
	QPixmap pix(*m_compassPath);
	m_image->setPixmap(pix);*/

	//Throw message to hide WindChanger
	//this->parentWidget()->setWind
	//QtTest01::setWind(QString("N"));
	//emit windChanged(*m_wind);
	emit windChanged();
	this->hide();
}

void WindChanger::buttonNEClicked()
{
	//QMessageBox::information(this, tr("Console"), "Set wind NE");
	m_wind = new QString("NE");
	setWindDirection(*m_wind);
	/*m_compassPath = new QString("Images/CompassNE_nb.png");
	QPixmap pix(*m_compassPath);
	m_image->setPixmap(pix);*/

	//Throw message to hide WindChanger
	//emit windChanged(*m_wind);
	emit windChanged();
	this->hide();
}


void WindChanger::buttonEClicked()
{
	//QMessageBox::information(this, tr("Console"), "Set wind E");
	m_wind = new QString("E");
	setWindDirection(*m_wind);
	/*m_compassPath = new QString("Images/CompassE_nb.png");
	QPixmap pix(*m_compassPath);
	m_image->setPixmap(pix);*/

	//Throw message to hide WindChanger
	//emit windChanged(*m_wind);
	emit windChanged();
	this->hide();
}

void WindChanger::buttonSEClicked()
{
	//QMessageBox::information(this, tr("Console"), "Set wind SE");
	m_wind = new QString("SE");
	setWindDirection(*m_wind);
	/*m_compassPath = new QString("Images/CompassSE_nb.png");
	QPixmap pix(*m_compassPath);
	m_image->setPixmap(pix);*/

	//Throw message to hide WindChanger
	//emit windChanged(*m_wind);
	emit windChanged();
	this->hide();
}

void WindChanger::buttonSClicked()
{
	//QMessageBox::information(this, tr("Console"), "Set wind S");
	m_wind = new QString("S");
	setWindDirection(*m_wind);
	/*m_compassPath = new QString("Images/CompassS_nb.png");
	QPixmap pix(*m_compassPath);
	m_image->setPixmap(pix);*/

	//Throw message to hide WindChanger
	//emit windChanged(*m_wind);
	emit windChanged();
	this->hide();
}

void WindChanger::buttonSWClicked()
{
	//QMessageBox::information(this, tr("Console"), "Set wind SW");
	m_wind = new QString("SW");
	setWindDirection(*m_wind);
	/*m_compassPath = new QString("Images/CompassSW_nb.png");
	QPixmap pix(*m_compassPath);
	m_image->setPixmap(pix);*/

	//Throw message to hide WindChanger
	//emit windChanged(*m_wind);
	emit windChanged();
	this->hide();
}

void WindChanger::buttonWClicked()
{
	//QMessageBox::information(this, tr("Console"), "Set wind W");
	m_wind = new QString("W");
	setWindDirection(*m_wind);
	/*m_compassPath = new QString("Images/CompassW_nb.png");
	QPixmap pix(*m_compassPath);
	m_image->setPixmap(pix);*/

	//Throw message to hide WindChanger
	//emit windChanged(*m_wind);
	emit windChanged();
	this->hide();
}

void WindChanger::buttonNWClicked()
{
	//QMessageBox::information(this, tr("Console"), "Set wind NW");
	m_wind = new QString("NW");
	setWindDirection(*m_wind);
	/*m_compassPath = new QString("Images/CompassNW_nb.png");
	QPixmap pix(*m_compassPath);
	m_image->setPixmap(pix);*/

	//Throw message to hide WindChanger
	//emit windChanged(*m_wind);
	emit windChanged();
	this->hide();
}