#ifndef WINDCHANGER_H
#define WINDCHANGER_H

#include <QtWidgets/QWidget>
#include <qgridlayout.h>
#include <qlabel.h>
#include "MyQPushButton.h"

class WindChanger : public QWidget
{
	Q_OBJECT
public:
	WindChanger(QWidget *parent = 0);
	~WindChanger();
	void setWindDirection(QString dir);
	QString* getWind();

signals:
	void windChanged(/*QString*/);

private slots:
	void buttonNClicked();
	void buttonNEClicked();
	void buttonEClicked();
	void buttonSEClicked();
	void buttonSClicked();
	void buttonSWClicked();
	void buttonWClicked();
	void buttonNWClicked();

private:
	QGridLayout *m_layout;
	MyQPushButton *m_buttonN;
	MyQPushButton *m_buttonNE;
	MyQPushButton *m_buttonE;
	MyQPushButton *m_buttonSE;
	MyQPushButton *m_buttonS;
	MyQPushButton *m_buttonSW;
	MyQPushButton *m_buttonW;
	MyQPushButton *m_buttonNW;
	QLabel *m_image;

	QString *m_compassPath;
	QString *m_wind;
};

#endif