#ifndef QTUI_H
#define QTUI_H

#include <QtWidgets/QWidget>
#include "MyQPushButton.h"
#include <qgroupbox.h>
#include "GLWidget.h"
#include "WindChanger.h"
#include "InformationPanel.h"
#include "ui_qtui.h"

class QtUI : public QWidget
{
	Q_OBJECT

public:
	QtUI(QWidget *parent = 0);
	~QtUI();

private slots:
	void updateButtonIcon();
	void updateButtonIconFocus();
	void buttonPlayPauseClicked();
	//void buttonInfoClicked();
	void buttonOpenSceneClicked();
	void buttonChangeWindClicked();
	void updateWindDirection(/*QString dir*/);

private:
	void createButtonsGroupBox();
	void createWindChanger();
	//void createInfoPanel();

	GLWidget *m_glwidget;
	WindChanger *m_windchanger;
	InformationPanel *m_infopanel;
	QGroupBox *m_groupBoxButtons;
	MyQPushButton *m_buttonPlayPause;
	MyQPushButton *m_buttonOpenScene;
	//MyQPushButton *m_buttonInfo;
	MyQPushButton *m_buttonChangeWindDir;

	Ui::QtUIClass ui;

	bool play;
	bool scene_load;
	//bool info_clicked;
};

#endif // QTUI_H
